package com.fp.persistence.pgeneral.gene;

import java.io.Serializable;
import java.lang.reflect.Field;

import javax.persistence.Column;
import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.EntityManager;
import javax.persistence.NoResultException;
import javax.persistence.Query;
import javax.persistence.Table;
import javax.persistence.Transient;
import javax.persistence.Version;

import com.fp.dto.hb.HibernateBean;
import com.fp.general.exception.GeneralException;

/** Clase que implementa la entidad de Hibernate que hace referencia a la tabla TGENEOFFICE */
@Entity(name = "TgeneOffice")
@Table(name = "TGENEOFFICE")
public class TgeneOffice extends com.fp.dto.AbstractDataTransport implements Serializable, HibernateBean, Cloneable {
    /**
     * HashCode asociado con la Instancia
     */
    @Transient
    private int hashValue = 0;

    /**
     * Version de la Clase
     */
    private static final long serialVersionUID = 1L;

    /**
     * Clave primaria de la Entidad TgeneOffice
     */
    @EmbeddedId
    private TgeneOfficeKey pk;

    @Version
    @Column(name = "RECORDVERSION", nullable = true)
    /**
     * Optimistic locking del registro
     */
    private Integer recordversion;

    @Column(name = "DESCRIPTION", nullable = true)
    /**
     * Nombre de la oficina
     */
    private String description;

    @Column(name = "COUNTRYCODE", nullable = true)
    /**
     * Codigo de pais
     */
    private String countrycode;

    @Column(name = "PROVINCECODE", nullable = true)
    /**
     * Codigo de provincia
     */
    private String provincecode;

    @Column(name = "CITYCODE", nullable = true)
    /**
     * Codigo de cuidad 
     */
    private String citycode;

    @Column(name = "ADDRESS", nullable = true)
    /**
     * Dieccion de la oficina.
     */
    private String address;

    @Column(name = "PHONE", nullable = true)
    /**
     * Numero de telefono asociado a la oficina.
     */
    private String phone;

    @Column(name = "CANTONCODE", nullable = true)
    /**
     * Codigo de canton
     */
    private String cantoncode;

    /** Contructor por defecto */
    public TgeneOffice() {
    }

    /**
     * Contructor de TgeneOffice
     * 
     * @param pPk Clave Primaria del entity
     */
    public TgeneOffice(TgeneOfficeKey pPk) {
        this();
        this.pk = pPk;
    }

    /**
     * Metodo que entrega datos de la tabla dada la clave primaria.
     * 
     * @param pEntityManager referencia de la session a obtener datos del bean.
     * @param pKey Caleve primaria del bean.
     * @return TgeneOffice
     */
    public static TgeneOffice find(EntityManager pEntityManager, TgeneOfficeKey pKey) throws Exception {
        TgeneOffice obj = pEntityManager.find(TgeneOffice.class, pKey);
        return obj;
    }

    /**
     * Entrega la Clave primaria de TgeneOffice
     * 
     * @return El objeto que referencia a la Clave primaria de TgeneOffice
     */
    public TgeneOfficeKey getPk() {
        return this.pk;
    }

    /**
     * Fija un nuevo valor a la Clave primaria de TgeneOffice
     * 
     * @param pPk El objeto que referencia a la nueva Clave primaria de TgeneOffice
     */
    public void setPk(TgeneOfficeKey pPk) {
        this.pk = pPk;
    }

    /**
     * Obtiene el valor de recordversion
     * 
     * @return valor de recordversion
     */
    public Integer getRecordversion() {
        return this.recordversion;
    }

    /**
     * Fija el valor de recordversion
     * 
     * @param pRecordversion nuevo Valor de recordversion
     */
    public void setRecordversion(Integer pRecordversion) {
        this.recordversion = pRecordversion;
    }

    /**
     * Obtiene el valor de description
     * 
     * @return valor de description
     */
    public String getDescription() {
        return this.description;
    }

    /**
     * Fija el valor de description
     * 
     * @param pDescription nuevo Valor de description
     */
    public void setDescription(String pDescription) {
        this.description = pDescription;
    }

    /**
     * Obtiene el valor de countrycode
     * 
     * @return valor de countrycode
     */
    public String getCountrycode() {
        return this.countrycode;
    }

    /**
     * Fija el valor de countrycode
     * 
     * @param pCountrycode nuevo Valor de countrycode
     */
    public void setCountrycode(String pCountrycode) {
        this.countrycode = pCountrycode;
    }

    /**
     * Obtiene el valor de provincecode
     * 
     * @return valor de provincecode
     */
    public String getProvincecode() {
        return this.provincecode;
    }

    /**
     * Fija el valor de provincecode
     * 
     * @param pProvincecode nuevo Valor de provincecode
     */
    public void setProvincecode(String pProvincecode) {
        this.provincecode = pProvincecode;
    }

    /**
     * Obtiene el valor de citycode
     * 
     * @return valor de citycode
     */
    public String getCitycode() {
        return this.citycode;
    }

    /**
     * Fija el valor de citycode
     * 
     * @param pCitycode nuevo Valor de citycode
     */
    public void setCitycode(String pCitycode) {
        this.citycode = pCitycode;
    }

    /**
     * Obtiene el valor de address
     * 
     * @return valor de address
     */
    public String getAddress() {
        return this.address;
    }

    /**
     * Fija el valor de address
     * 
     * @param pAddress nuevo Valor de address
     */
    public void setAddress(String pAddress) {
        this.address = pAddress;
    }

    /**
     * Obtiene el valor de phone
     * 
     * @return valor de phone
     */
    public String getPhone() {
        return this.phone;
    }

    /**
     * Fija el valor de phone
     * 
     * @param pPhone nuevo Valor de phone
     */
    public void setPhone(String pPhone) {
        this.phone = pPhone;
    }

    /**
     * Obtiene el valor de cantoncode
     * 
     * @return valor de cantoncode
     */
    public String getCantoncode() {
        return this.cantoncode;
    }

    /**
     * Fija el valor de cantoncode
     * 
     * @param pCantoncode nuevo Valor de cantoncode
     */
    public void setCantoncode(String pCantoncode) {
        this.cantoncode = pCantoncode;
    }

    @Override
    public boolean equals(Object rhs) {
        if (rhs == null) {
            return false;
        }
        if (!(rhs instanceof TgeneOffice)) {
            return false;
        }
        TgeneOffice that = (TgeneOffice) rhs;
        if ((this.getPk() == null) || (that.getPk() == null)) {
            return false;
        }
        return (this.getPk().equals(that.getPk()));
    }

    /**
     * Implementacion del metodo hashCode de la la entidad TgeneOffice
     * 
     * @return el hashCode la instancia
     */
    @Override
    public int hashCode() {
        if (this.hashValue == 0) {
            int result = 17;
            if (this.getPk() == null) {
                result = super.hashCode();
            } else {
                result = this.getPk().hashCode();
            }
            this.hashValue = result;
        }
        return this.hashValue;
    }

    /** Implementacion toString */
    @Override
    public String toString() {
        Field[] fs = this.getClass().getDeclaredFields();
        String data = "";
        for (Field f : fs) {
            try {
                String name = f.getName();
                if (f.getType().getName().compareTo("java.util.Set") == 0) {
                    continue;
                }
                if ((name.compareTo("hashValue") == 0) || (name.compareTo("serialVersionUID") == 0)) {
                    continue;
                }
                data += name + "=" + f.get(this) + ";";
            } catch (Exception e) {
                continue;
            }
        }
        if (data.compareTo("") == 0) {
            data = super.toString();
        }
        return data;
    }

    /** Implementacion de la creacion de un bean en blanco TgeneOffice */
    @Override
    public Object createInstance() {
        TgeneOffice instance = new TgeneOffice();
        instance.setPk(new TgeneOfficeKey());
        return instance;
    }

    /**
     * Clona la entidad TgeneOffice
     * 
     * @see com.fp.dto.hb.HibernateBean#cloneMe()
     */
    @Override
    public Object cloneMe() throws CloneNotSupportedException {
        TgeneOffice p = (TgeneOffice) this.clone();
        p.setPk((TgeneOfficeKey) this.pk.cloneMe());
        return p;
    }
}
